import java.awt.*;
import java.awt.event.*;

public class Main extends Frame implements ActionListener {
    Button addButton = new Button("Add");
    Button removeButton = new Button("Remove");
    List list = new List();

    Main() {
        super("ActionEvent.SHIFT_MASK Example");
        addItems();

        // Listen for events
        addButton.addActionListener(this);
        removeButton.addActionListener(this);

        // Layout components
        add(addButton, BorderLayout.NORTH);
        add(removeButton, BorderLayout.SOUTH);
        add(list, BorderLayout.CENTER);
        setSize(150, 200);
        show();
    }

    public void actionPerformed(ActionEvent evt) {
        if ("Add".equals(evt.getActionCommand())) {
            addItems();
        } else if ("Remove".equals(evt.getActionCommand())) {
            // If the shift key is enabled, remove all the items.
            if ((evt.getModifiers() & ActionEvent.SHIFT_MASK) != 0) {
                list.removeAll();
            } else if (list.getSelectedIndex() >= 0) {
                list.remove(list.getSelectedIndex());
            }
        }
    }

    // Generate some random items.
    void addItems() {
        for (int i=0; i<5; i++) {
            list.addItem(""+Math.random());
        }
    }
        

    public static void main(String args[]) {
        new Main();
    }
}
