import java.awt.*;
import java.awt.event.*;

class Main extends Frame {
    Main() {
        super("FOCUS_LOST Example");
        Component c;

        setLayout(new FlowLayout());

        add(new Button("Button"));
        add(new Checkbox("Checkbox"));
        add(c = new List());
        ((List)c).addItem("List");
        add(c = new Choice());
        ((Choice)c).addItem("Choice");
        add(new TextField("TextField"));
        pack();
        show();

        new HelpManager(this);
    }

    public static void main(String[] args) {
        new Main();
    }
}

class HelpManager extends Thread {
    Component focusOwner;
    Window window;

    HelpManager(Window w) {
        window = w;
        start();
    }

    public void run() {
        while (focusOwner == null) {
            try {
                focusOwner = window.getFocusOwner();
                Thread.sleep(1000);
            } catch (Exception e) {
            }
        }
        focusOwner.addFocusListener(new FocusEventHandler());
    }

/*
    class KeyEventHandler extends KeyAdapter {
        public void keyTyped(KeyEvent evt) {
            if (evt.getKeyCode() == KeyEvent.VK_TAB) {
            }
        }
    }
*/

    class FocusEventHandler extends FocusAdapter {
        public void focusLost(FocusEvent evt) {
            System.out.println("lost: "+evt.getComponent());
            evt.getComponent().removeFocusListener(this);
            System.out.println("got: "+window.getFocusOwner());
            window.getFocusOwner().addFocusListener(this);
        }
    }
}