import java.awt.*;
import java.awt.event.*;

class Main extends Frame {
    Label statusbar = new Label("Ready");

    Main() {
        super("MouseAdapter Example");
        MainButton b;
        MouseEventHandler mhandler = new MouseEventHandler();
        Panel toolbar = new Panel(new FlowLayout());

        // Create the buttons.
        b = new MainButton("Create", "Create a new document.");
        b.addMouseListener(mhandler);
        toolbar.add(b);
        b = new MainButton("Open", "Open an existing document.");
        b.addMouseListener(mhandler);
        toolbar.add(b);
        b = new MainButton("Save", "Save the current document.");
        b.addMouseListener(mhandler);
        toolbar.add(b);
        b = new MainButton("Close", "Close the current document.");
        b.addMouseListener(mhandler);
        toolbar.add(b);

        add(toolbar, BorderLayout.CENTER);
        add(statusbar, BorderLayout.SOUTH);

        pack();
        show();
    }

    class MouseEventHandler extends MouseAdapter {
        public void mouseEntered(MouseEvent evt) {
            statusbar.setText(
                ((MainButton)evt.getSource()).getDescription());
        }
        public void mouseExited(MouseEvent evt) {
            statusbar.setText(null);
        }
    }
    
    public static void main(String args[]) {
        new Main();
    }
}

// The main purpose of this button subclass is simply to hold
// a description string.
class MainButton extends Button {
    String desc;

    MainButton(String label, String desc) {
        super(label);
        this.desc = desc;
    }

    String getDescription() {
        return desc;
    }
}