import java.awt.*;
import java.awt.event.ItemListener;
import java.awt.event.ItemEvent;

class Main extends Frame implements ItemListener {
    Checkbox cbAC = new Checkbox("Air Conditioning");
    Checkbox cbSR = new Checkbox("Sun Roof");
    Checkbox cbSW = new Checkbox("Steering Wheel");
    Checkbox cbTR = new Checkbox("Tires");
    Label status = new Label();

    Main() {
        super("Checkbox Example");
        Panel gridPanel = new Panel(new GridLayout(0, 1));
        gridPanel.add(cbAC);
        gridPanel.add(cbSR);
        gridPanel.add(cbSW);
        gridPanel.add(cbTR);
        add(gridPanel, BorderLayout.CENTER); 

        // Set listener for each checkbox
        cbAC.addItemListener(this);
        cbSR.addItemListener(this);
        cbSW.addItemListener(this);
        cbTR.addItemListener(this);

        computeTotal();
        add(status, BorderLayout.SOUTH); 
        pack();
        show();
    }

    public void itemStateChanged(ItemEvent evt) {
        computeTotal();
    }

    void computeTotal() {
        int total = 25000;
        if (cbAC.getState()) total += 510;
        if (cbSR.getState()) total += 2222;
        if (cbSW.getState()) total += 150;
        if (cbTR.getState()) total += 320;
        status.setText("Total Sticker Price: $" + total);
    }

    static public void main(String[] args) {
        new Main();
    }
}
