import java.awt.*;
import java.awt.event.*;
import java.util.ResourceBundle;
import java.util.Locale;

public class Main extends Frame {
    Main() {
        super("getName Example");
    }

    void init(ItemListener l) {
        // Get localized labels for checkboxes
        ResourceBundle rb = ResourceBundle.getBundle("MyBundle", getLocale());
        String one = rb.getString("checkboxOne");
        String two = rb.getString("checkboxTwo");
        String three = rb.getString("checkboxThree");

        // Create checkboxes
        CheckboxGroup cg = new CheckboxGroup();
        Checkbox c1 = new Checkbox(one, cg, true);
        Checkbox c2 = new Checkbox(two, cg, false);
        Checkbox c3 = new Checkbox(three, cg, false);

        // Set internationalized identifiers for checkboxes
        c1.setName("one");
        c2.setName("two");
        c3.setName("three");

        // Add listener for checkboxes
        c1.addItemListener(l);
        c2.addItemListener(l);
        c3.addItemListener(l);

        // Add checkboxes to frame
        add(c1, BorderLayout.NORTH);
        add(c2, BorderLayout.CENTER);
        add(c3, BorderLayout.SOUTH);

        setSize(100, 100);
        show();
    }

    static public void main(String[] args) {
        Main m = new Main();

        // Set locale of component 
        m.setLocale(Locale.FRANCE);
        m.init(new ItemEventHandler());
    }
}

class ItemEventHandler implements ItemListener {
    public void itemStateChanged(ItemEvent evt) {
        Component src = (Component)evt.getSource();
        String target = src.getName();
        int number = 0;

        if (target.equals("one")) {
            number = 1;
        } if (target.equals("two")) {
            number = 2;
        } if (target.equals("three")) {
            number = 3;
        }
        System.out.println("number=" + number);
    }
}
