import java.awt.*;

class Main extends Frame implements Runnable {
    int x;      // Continuously moving x-location of the image.
    Image image;

    Main(String filename) {
        super("update Example");

        // Get the image.
        image = getToolkit().getImage(filename);

        (new Thread(this)).start();
        setSize(300, 160);
        show();
    }

    public void paint(Graphics g) {
        update(g);
    }

    public void update(Graphics g) {
        int w = image.getWidth(this);

        // Draw left-most image.
        g.drawImage(image, x, getInsets().top, this);

        if (w > 0) {
            // Draw additional images to fill the display.
            for (int i=1; i<=getSize().width/w+1; i++) {
                g.drawImage(image, x+i*w, getInsets().top, this);
            }
        }
    }

    public void run() {
        try {
            while (true) {
                int w = image.getWidth(this);

                if (w > 0) {
                    x = (x-1) % w;
                    repaint();
                }
                Thread.sleep(100);
            }
        } catch (Exception e) {
            e.printStackTrace();
        }
    }

    public static void main(String[] args) {
        if (args.length == 1) {
            new Main(args[0]);
        } else {
            System.err.println("Usage: java Main <image-file>");
        }
    }
}
