import java.awt.*;
import java.awt.event.*;

class Main extends Frame {
    int fontPointSize = 40;
    char[] message = {'J', 'a', 'v', 'a'};

    Main() {
        super("getMaxAdvance Example");

        addKeyListener(new KeyEventHandler());

        setSize(300, 150);
        show();
    }

    public void paint(Graphics g) {
        Insets insets = this.getInsets();
        int w = getSize().width-insets.left-insets.right;
        int h = getSize().height-insets.top-insets.bottom;
        int x = insets.left;
        int y = insets.top;
        FontMetrics fm = g.getFontMetrics(
            new Font("Serif", Font.BOLD+Font.ITALIC, fontPointSize));

        // Determine size of one box.  Add some padding (use the leading
        // value) around the inside of each box.
        Dimension dim = new Dimension(fm.getMaxAdvance()+2*fm.getLeading(),
            fm.getMaxAscent() + fm.getMaxDescent() + 2*fm.getLeading());

        // Determine bounding rectangle for all boxes; include some spacing
        // between the boxes.
        Rectangle r = new Rectangle(0, 0,
            message.length * dim.width + (message.length-1) * fm.getLeading(), 
            dim.height);

        //Now center the rectangle.
        r.setLocation(x+(w-r.width)/2, y+(h-r.height)/2);

        g.clearRect(x, y, w, h);
        g.setFont(fm.getFont());
        for (int i=0; i<message.length; i++) {
            int cW = fm.charsWidth(message, i, 1);
            int cH = fm.getMaxAscent() + fm.getMaxDescent() + fm.getLeading();

            g.drawChars(message, i, 1, r.x + (dim.width-cW)/2, 
                r.y + (dim.height-cH)/2 + fm.getMaxAscent());
            g.drawRect(r.x, r.y, dim.width-1, r.height-1);
            r.x += dim.width + fm.getLeading();
        }
    }

    class KeyEventHandler extends KeyAdapter {
        public void keyPressed(KeyEvent evt) {
            char key = evt.getKeyChar();
            if (key == '+') {
                fontPointSize++;
            } else if (key == '-') {
                fontPointSize--;
            }
            repaint();
        }
    }

    static public void main(String[] args) {
        new Main();
    }
}
