import java.awt.*;
import java.awt.event.*;

class Main extends Frame {
    int borderWidth = 5;
    boolean raised = true;

    Main() {
        super("draw3DRect Example");
        setSize(200, 200);

        addMouseListener(new MouseEventHandler());
        show();
    }

    public void paint(Graphics g) {
        Insets insets = this.getInsets();
        int x = insets.left, y = insets.top;
        int w = getSize().width-insets.left-insets.right;
        int h = getSize().height-insets.top-insets.bottom;

        w -= 1;       // draw inside the rectangle.
        h -= 1;       // draw inside the rectangle.
        g.setColor(getBackground());
        for (int i=0; i<borderWidth; i++) {
            g.draw3DRect(x++, y++, w, h, raised);
            w -= 2;
            h -= 2;
        }
        g.fillRect(x, y, w+1, h+1);
    }

    class MouseEventHandler extends MouseAdapter {
        public void mousePressed(MouseEvent evt) {
            raised = !raised;
            repaint();
        }
    }

    static public void main(String[] args) {
        new Main();
    }
}
