import java.awt.*;
import java.awt.event.*;

class Main extends Frame implements ActionListener {
    Main() {
        super("Cascading Example");
        MenuBar mb = new MenuBar();
        Menu m = new Menu("File");
        Menu newMenu = new Menu("New");
        MenuItem mi = newMenu.add(
            new MenuItem("Directory", new MenuShortcut(KeyEvent.VK_D)));
        mi.setActionCommand("Directory");
        mi = newMenu.add(
            new MenuItem("File", new MenuShortcut(KeyEvent.VK_F)));
        mi.setActionCommand("File");
        m.add(newMenu);

        Menu imp = new Menu("Import");
        Menu format = new Menu("Format");
        format.add("Character");
        format.add("Paragraph");
        format.add("Variable Definition");
        imp.add(format);
        imp.add("File");

        m.add(imp);
        m.add("Save");
        m.addSeparator();
        m.add("Exit");

        mb.add(m);

        // Add action listener for main menu and submenus
        m.addActionListener(this);
        newMenu.addActionListener(this);
        imp.addActionListener(this);
        format.addActionListener(this);

        // Set the menu bar on the frame.
        setMenuBar(mb);

        setSize(100, 100);    
        show();
    }

    public void actionPerformed(ActionEvent evt) {
        System.out.println(evt.getActionCommand());
    }

    static public void main(String[] args) {
        new Main();
    }
}
