import java.awt.*;
import java.awt.event.*;
import java.util.Enumeration;

class Main extends Frame implements ActionListener {
    MenuBar mb = new MenuBar();
    MenuShortcut shortcut = new MenuShortcut(KeyEvent.VK_S);
    MenuItem mi;
    Button view = new Button("Show");
    Button delete = new Button("Delete");
    Button add = new Button("Add");
    boolean delsc = false;

    Main() {
        super("deleteShortcut Example");
        Menu m = new Menu("File");

        mi = new MenuItem("Save", shortcut);
        mi.setActionCommand("Save");  // required for shortcut
        m.add(mi);
        
        // Add listener for menu (and its menu items)
        m.addActionListener(this);

        // Set the menu bar on the frame.
        mb.add(m);
        setMenuBar(mb);

        // Add controls for viewing, deleting, adding shortcuts
        Panel p = new Panel(new GridLayout(1, 0));
        add.setEnabled(false);
        p.add(view);
        p.add(delete);
        p.add(add);

        delete.addActionListener(this);
        view.addActionListener(this);
        add.addActionListener(this);

        add(new TextArea("Text area"), BorderLayout.CENTER);
        add(p, BorderLayout.SOUTH);

        setSize(100, 100);    
        show();
    }

    public void actionPerformed(ActionEvent evt) {
        if (evt.getSource() instanceof MenuItem) {
            System.out.println(evt.getActionCommand());
        } else if (evt.getSource() instanceof Button) {
            String sc = evt.getActionCommand();
            if (sc.equals("Show")) {
                System.out.println(mi.getShortcut());
            } else if (sc.equals("Delete")) {
                mi.deleteShortcut();
                delete.setEnabled(false);
                add.setEnabled(true);
            } else if (sc.equals("Add")) {
                mi.setShortcut(shortcut);
                add.setEnabled(false);
                delete.setEnabled(true);
            }
        }
    }

    static public void main(String[] args) {
        new Main();
    }
}
