import java.awt.*;
import java.awt.event.*;
import java.util.ResourceBundle;
import java.util.Locale;

public class Main extends Frame {
    Main() {
        super("setActionCommand Example");
    }

    void init(ActionListener l) {
        // Get localized labels for menu items
        ResourceBundle rb = ResourceBundle.getBundle("MyBundle", getLocale());
        String one = rb.getString("menuitemOne");
        String two = rb.getString("menuitemTwo");
        String three = rb.getString("menuitemThree");
        String heading = rb.getString("menuHeading");

        // Create checkboxes
        Menu menu = new Menu(heading);
        MenuItem m1 = new MenuItem(one);
        MenuItem m2 = new MenuItem(two);
        MenuItem m3 = new MenuItem(three);

        // Set internationalized identifiers for menu and menuitems
        menu.setName("number");
        m1.setActionCommand("one");
        m2.setActionCommand("two");
        m3.setActionCommand("three");

        // Add listener for menu and menu items
        menu.addActionListener(l);
        m1.addActionListener(l);
        m2.addActionListener(l);
        m3.addActionListener(l);

        // Add menu items to menu
        menu.add(m1);
        menu.add(m2);
        menu.add(m3);

        MenuBar mb = new MenuBar();
        mb.add(menu);
        setMenuBar(mb);

        setSize(100, 100);
        show();
    }

    static public void main(String[] args) {
        Main m = new Main();

        // Set locale of component 
        m.setLocale(Locale.FRANCE);
        m.init(new ActionEventHandler());
    }
}

class  ActionEventHandler implements ActionListener {
    public void actionPerformed(ActionEvent evt) {
        String target = evt.getActionCommand();
        int number = 0;

        if (target.equals("one")) {
            number = 1;
        } if (target.equals("two")) {
            number = 2;
        } if (target.equals("three")) {
            number = 3;
        }
        System.out.println("number = " + number);
    }
}
