import java.awt.*;
import java.awt.event.*;

class Main extends Frame implements ActionListener {
    Main() {
        super("MenuShortcut Example");
        Menu m = new Menu("File");

        // Create menu items with shortcuts
        MenuItem mi = 
            new MenuItem("Edit", new MenuShortcut(KeyEvent.VK_E));
        mi.setActionCommand("Edit");  // required for shortcut
        mi.addActionListener(this);
        m.add(mi);

        mi = new MenuItem("Save", new MenuShortcut(KeyEvent.VK_S));
        mi.setActionCommand("Save");  // required for shortcut
        m.add(mi);
        mi.addActionListener(this);

        // Set the menu bar on the frame.
        MenuBar mb = new MenuBar();
        mb.add(m);
        setMenuBar(mb);

        setSize(100, 100);    
        show();
    }

    public void actionPerformed(ActionEvent evt) {
        if (evt.getSource() instanceof MenuItem) {
            MenuItem mi = (MenuItem)evt.getSource();
            System.out.println("Source = " +  mi.toString());
            MenuShortcut ms = mi.getShortcut();
            if (ms != null) {
                System.out.println("\tKey = " + ms.getKey());
                System.out.println("\tShift = " + ms.usesShiftModifier());
            }
        }
        System.out.println("Action Command = " + evt.getActionCommand());
    }

    static public void main(String[] args) {
        new Main();
    }
}
