import java.awt.*;
import java.awt.event.*;

class Main extends Frame {
    Component[] comp = 
        new Component[11];
    PopupMenu[] popup = 
        new PopupMenu[11];

    Main() {
        super("show() Example");
        setLayout(new FlowLayout());

        // Create various types of components
        comp[0] = new TextArea("this is a text area", 3, 10);
        comp[1] = new TextField("this is a text field");
        comp[2] = new Button("Button");
        comp[3] = new Label("Label");
        comp[4] = new Checkbox("Checkbox");
        Choice c = new Choice();
        c.addItem("a");
        c.addItem("b");
        c.addItem("c");
        comp[5] = c;
        comp[6] = new Scrollbar(Scrollbar.HORIZONTAL);
        Canvas canvas = new MyCanvas();
        canvas.setSize(20, 20);
        comp[7] = canvas;
        List l = new List();
        comp[8] = l;
        l.addItem("one");
        l.addItem("two");
        l.addItem("three");
        Component lw = new MyComponent();
        comp[9] = lw;
        comp[10] = this;
        
        MouseListener ml = new MouseEventHandler();

        // Add listener and popup menus to components 
        for (int i = 0; i <= 10; i++) {
            comp[i].addMouseListener(ml);
            popup[i] = new PopupMenu("popup" + i);
            popup[i].add("popup item "+i);
            comp[i].add(popup[i]);
            if (i != 10)
                add(comp[i]);
        }

        setSize(150, 150);
        show();
    }

    // Native component
    class MyCanvas extends Canvas {
        public void paint(Graphics g) {
            g.drawOval(0, 0, getSize().width, getSize().height);
        }
    }

    // Lightweight component
    class MyComponent extends Component {
        public Dimension getPreferredSize() {
            return new Dimension(20, 20);
        }
        public void paint(Graphics g) {
            g.fillOval(0, 0, getSize().width, getSize().height);
        }
    }


    // Override mouseReleased() and mousePressed() to
    // catch popup menu trigger.
    class MouseEventHandler extends MouseAdapter {
        int findComponent(Component c) {
            for (int i = 0; i <= 10; i++) {
                if (c.equals(comp[i])) {
                    return i;
                }
            }
            return -1;
        }
        public void mouseReleased(MouseEvent evt) {
            if (evt.isPopupTrigger()) {
                int i = findComponent((Component)evt.getSource());
                if (i > 0) {
                    popup[i].show(comp[i], evt.getX(), evt.getY());
                } else {
                    System.out.println("no popup");
                }
            }
        }
        public void mousePressed(MouseEvent evt) {
            if (evt.isPopupTrigger()) {
                int i = findComponent((Component)evt.getSource());
                if (i > 0) {
                    popup[i].show(comp[i], evt.getX(), evt.getY());
                } else {
                    System.out.println("no popup");
                }
            }
        }
    }

    public static void main(String args[]) {
        new Main();
    }
}
