import java.applet.*;
import java.awt.*;
import java.awt.event.*;
import java.beans.*;

public class Bean extends Applet implements Runnable {
    Image image;
    Thread thread;
    Point curLoc = new Point(0, 0);
    int scale = 1;

    // This method is automatically called by Beans.instantiate().
    public void init() {
        image = getImage(getDocumentBase(), "duke.gif");

        // Make sure the entire image is loaded so that we can safely
        // call getWidth() and getHeight() on it.
        MediaTracker tracker = new MediaTracker(this);
        try {
            tracker.addImage(image, 0);
            tracker.waitForAll(0);
        } catch (Exception e) {
            e.printStackTrace();
        }

        // Listen for mouse pressed events.
        addMouseListener(new MouseEventHandler());
    }

    public void start() {
        // Start the animation thread.
        (thread = new Thread(this)).start();
    }

    public void stop() {
        // Stop the animation thread.
        thread = null;
    }

    public void paint(Graphics g) {
        if (Beans.isDesignTime()) {
            g.drawImage(image, curLoc.x, curLoc.y, this);
        } else {
            g.drawImage(image, curLoc.x, curLoc.y, 
                image.getWidth(null)/scale, image.getHeight(null)/scale, this);
        }
    }

    class MouseEventHandler extends MouseAdapter {
        public void mousePressed(MouseEvent evt) {
            // Ignore mouse events unless in design-time mode.
            if (Beans.isDesignTime()) {
                curLoc = evt.getPoint();
                repaint();
            }
        }
    }

    // Thread that constantly changes the scale value.
    public void run() {
        int inc = 1;
        while (thread == Thread.currentThread()) {
            try {
                if (!Beans.isDesignTime()) {
                    if (scale == 1) {
                        inc = 1;
                    } else if (scale == 5) {
                        inc = -1;
                    }
                    scale += inc;
                    repaint();
                }
                Thread.sleep(300);
            } catch (Exception e) {
            }
        }
    }
}