import java.awt.*;
import java.beans.*;

public class Bean extends Component {
    public Bean() {
    }

    // Some dummy methods.
    public Image getImage() {
        // Need to return a non-null image, otherwise 
        // property editor is not created.
        return createImage(1, 1);
    }
    public void setImage(Image image) {
    }

    static {
        String[] searchPath = PropertyEditorManager.getEditorSearchPath();
        String[] newPath = new String[searchPath.length + 1];

        newPath[0] = "editors";
        for (int i=0; i<searchPath.length; i++) {
            newPath[i+1] = searchPath[i];
        }
        PropertyEditorManager.setEditorSearchPath(newPath);

        // Clear out current entry.
        PropertyEditorManager.registerEditor(Color.class, null);

        // Rather than set search path, the bean could instead explicitly
        // register the property editor, like so:
        //PropertyEditorManager.registerEditor(Color.class, 
        //    editors.ColorEditor.class);

        // Just checking to see if the search path worked.
        PropertyEditor pe = null;
        try {
            pe = PropertyEditorManager.findEditor(Color.class);
            if (pe == null) {
                System.err.println("Could not find the color editor");
            }

            String s = pe.getClass().getName();
            if (!s.equals("editors.ColorEditor")) {
                System.err.println("Wrong color editor found");
            }
        } catch (Exception e) {
            e.printStackTrace();
        }
    }
}
/* 
    manifest.txt:
        Name: Bean.class
        Java-Bean: True
    jar command:
        jar cfm bean.jar manifest.txt *.class editors/*.class
*/
 
