import java.beans.*;
import java.util.*;

public class IpEditor extends PropertyEditorSupport {
    // Make sure the string is in the form of an ip address.
    public void setAsText(String text) throws IllegalArgumentException {
        // Break text up into strings separated by dots.
        StringTokenizer st = new StringTokenizer(text, ".");
        int result = 0;

        try {
            for (int i=0; i<4; i++) {
                int t = Integer.parseInt(st.nextToken());

                if (t < 0 || t > 255) {
                    throw new IllegalArgumentException(text);
                }
                result |= (t<<(3-i)*8);
            }
            setValue(new Ip(result));
        } catch (Exception e) {
            // It doesn't matter what the exception is.
        }
        throw new IllegalArgumentException(text);
    }
}