import java.beans.*;

public class BeanBeanInfo extends SimpleBeanInfo {
    public BeanInfo[] getAdditionalBeanInfo() {
        try {
            BeanInfo[] bi = new BeanInfo[1];

            bi[0] = Introspector.getBeanInfo(Bean.class.getSuperclass());
            return bi;
        } catch (IntrospectionException e) {
            e.printStackTrace();
        }
        return null;
    }

    public BeanDescriptor getBeanDescriptor() {
        BeanDescriptor bd = new BeanDescriptor(Bean.class);

        bd.setDisplayName("Bean\u00a9");    // Copyright symbol
        return bd;
    }

    public MethodDescriptor[] getMethodDescriptors() {
        try {
            MethodDescriptor md[] = new MethodDescriptor[1];

            md[0] = new MethodDescriptor(Bean.class.getMethod("method", null));
            return md;
        } catch (NoSuchMethodException e) {
            e.printStackTrace();
        }
        return null;
    }

    public int getDefaultPropertyIndex() {
        return 1;
    }
    public PropertyDescriptor[] getPropertyDescriptors() {
        try {
            PropertyDescriptor pd[] = new PropertyDescriptor[2];

            // The getter and setter methods are derived from the property name.
            pd[0] = new PropertyDescriptor("property1", Bean.class);
            pd[1] = new PropertyDescriptor("property2", Bean.class);

            return pd;
        } catch (IntrospectionException e) {
            e.printStackTrace();
        }
        return null;
    }

    public int getDefaultEventIndex() {
        return 1;
    }
    public EventSetDescriptor[] getEventSetDescriptors() {
        try {
            EventSetDescriptor[] esd = new EventSetDescriptor[2];

            esd[0] = new EventSetDescriptor(Bean.class,
                        "event1", JumpListener.class, "beanJumped");

            esd[1] = new EventSetDescriptor(Bean.class,
                        "event2", JumpListener.class, "beanJumped");

            return esd;
        } catch (IntrospectionException e) {
            e.printStackTrace();
        }
        return null;
    }

    public java.awt.Image getIcon(int iconKind) {
        switch (iconKind) {
          case ICON_COLOR_16x16:
            return loadImage("duke-color-16x16.gif");
          case ICON_COLOR_32x32:
            return loadImage("duke-color-32x32.gif");
          case ICON_MONO_16x16:
            return loadImage("duke-mono-16x16.gif");
          case ICON_MONO_32x32:
            return loadImage("duke-mono-32x32.gif");
          default:
            return null;
        }
    }
}
