import java.beans.*;

class Main {
    public static void main(String[] args) {
        Bean bean = null;

        if (args.length != 1) {
            System.out.println("Usage: java Main [yes|no]");
            System.exit(1);
        }
        
        // Should the bean use a gui?
        boolean useGui = args[0].equals("yes");

        Beans.setGuiAvailable(useGui);

        try {
            // Create the bean.
            bean = (Bean)Beans.instantiate(Main.class.getClassLoader(), "Bean");
        } catch (Exception e) {
            e.printStackTrace();
            System.err.println("Failed to create bean.");
            System.exit(1);
        }

        if (Beans.isGuiAvailable()) {
            bean.okToUseGui();
        } else {
            bean.dontUseGui();
        }
    }
}
